'-----------------------------------------------------------------------------------------
'name                     : pga2310_m8515_6in_encoder.bas
'copyright                : (c) danzup
'purpose                  : PGA Preamp controller
'micro                    : AtMega8515
'version                  : 1.enc
' this version with 6 input, RC5 remote control & PGA2310 volume  ,
' mute ,backlight LED  control  , with Encoder : A-->PD2 ,B-->PD1 ,C -->GND
'  modified time delay for volume set , stop at +3dB for PGA2310
'-----------------------------------------------------------------------------------------
$regfile = "m8515.dat"                                      ' specify the used micro
$crystal = 8000000                                          ' used crystal frequency
Ddrd = &B11000000                                           ' PD6...PD7 are output, PD0...PD5 are input
Portd = &B00111111                                          ' PD0...PD5 pull-up resistor enable
Ddra = &B11111111                                           ' PA0...PA7 are output ,input relay control
Ddrb = &B11111111                                           ' PB0...PB7 are output
Config Lcdpin = Pin , Db4 = Portc.2 , Db5 = Portc.3 , Db6 = Portc.4 , Db7 = Portc.5 , E = Portc.1 , Rs = Portc.0
Config Spi = Soft , Din = Portb.0 , Dout = Portb.1 , Ss = Portb.2 , Clock = Portb.4
Config Porta = Output
Config Portb.3 = Output                                     'mute line for PGA2310
Dim Address As Byte , Command As Byte                       'RC5 ir variable
Dim A As Bit                                                'On/Off button  PortD.0
Dim B As Bit                                                'Menu button  PortD.4
Dim W As Word
Dim G As Byte
Dim Inp_sel As Byte
Dim Pwr As Bit
Dim Mut As Bit
Dim Vol_out As Byte
Dim L As Byte
Dim R As Byte
L = 70
R = 70
Reset Portb.3                                               'mute PGA2310
Declare Sub Spio                                            '
Declare Sub Shiftlf                                         '
Declare Sub Shiftrt                                         '
Declare Sub Volup                                           '
Declare Sub Voldn                                           '
Declare Sub Poweron                                         '
Declare Sub Poweroff                                        '
Declare Sub Af_sel                                          '
Declare Sub Pwr_onof                                        '
Declare Sub Mute                                            '
Declare Sub Balance_r                                       '
Declare Sub Balance_l                                       '
Declare Sub Menu                                            '
Declare Sub Bklght                                          '
Cursor Off
Encb Alias Pind.1
Set Encb
On Int0 Int_0                                               'we enable the INT0 interrupt
Enable Int0                                                 'we configure the INT0 interrupt to trigger when a falling edge is detected
Config Int0 = Falling
Config Lcd = 16 * 2                                         'other options are 16 * 4 and 20 * 4, 20 * 2 , 16 * 1a
Config Rc5 = Pind.3                                         'pin where is conected ir senzor
Config Timer1 = Timer , Prescale = 1024
Stop Timer1
Start Timer1
Set Portd.7                                                 'backlight on
Reset Portb.3                                               'mute PGA2310
Spiinit                                                     'init the spi bus for PGA2310 talk with
Call Spio
Pwr = 0                                                     '0 =stand-by ; 1 = power on
Mut = 1                                                     ' 0 =mute , 1 = normal
Inp_sel = &B00000001                                        'default selected first input
Cls                                                         'clear the LCD display
Porta = Inp_sel                                             ' will set the input  selected default
Lcd "Preamp controler"                                      'display this at the top line
Lowerline                                                   'select the lower line
Lcd "v=1.enc(c)danzup"                                      'display this at the lower line
Wait 1
Cls
Enable Interrupts
'--------------------------------------------------------------------------
If Pwr = 0 Then
Call Poweroff
End If
'--------------------------------------------------------------------------
Do

If Pwr = 1 Then
 If W => 33800 Then
  Reset Portd.7                                             'will set the Port D bit 7 to 0V backlight off
 End If
Getrc5(address , Command)                                   'read if we have remote ir command
  If Address = 8 Then
     Command = Command And &B01111111
  End If
Select Case Command
'---- this codes are for my remote , change code to your suit ! ----------------
   Case 32 : Call Shiftlf                                   'remote command code for CH up
   Case 33 : Call Shiftrt                                   'remote command code for CH down
   Case 17 : Call Volup                                     'remote command code for Vol +
   Case 16 : Call Voldn                                     'remote command code for Vol -
   Case 13 : Call Mute                                      'remote command code for Mute
   Case 12 : Call Pwr_onof                                  'remote command code for On/Off
End Select
A = Pind.0                                                  'On/Off button
B = Pind.4                                                  'Menu button
   If A = 0 Then                                            'now we read the push buttons for command
      Waitms 2
      Call Pwr_onof                                         'button On/Off presed
   End If
   If B = 0 Then
      Waitms 2
      Call Menu                                             'button Menu presed
   End If
End If

If Pwr = 0 Then
A = Pind.0                                                  'On/Off button
 Getrc5(address , Command)                                  'read if we have remote ir command
  If Address = 8 Then
     Command = Command And &B01111111
  End If
 Select Case Command
 '---- this codes are for my remote , change code to your suit ! ----------------
   Case 12 : Call Pwr_onof                                  'remote command code for On/Off
 End Select
 If A = 0 Then                                              'now we read the push buttons for command
      Waitms 2
      Call Pwr_onof                                         'button On/Off presed
 End If
End If

Loop

End

'-------------------Int_0------------------------
Int_0:
Disable Int0
  If Encb = 0 Then
    If G = 0 Then
      Call Volup
    End If
    If G = 1 Then
       Call Shiftlf
    End If
  Else
    If G = 0 Then
      Call Voldn
    End If
    If G = 1 Then
       Call Shiftrt
    End If
  End If
Gifr = 64                                                   'asta e cea mai mare smecherie !
Enable Int0
Return
'-----------Pwr_onof-----------------
Sub Pwr_onof:
   Pwr = Not Pwr
   If Pwr = 1 Then
      Call Poweron
   Else
      Call Poweroff
   End If
End Sub
'------Poweron------------------------
Sub Poweron:
Set Portb.3                                                 'unmute  PGA2310
Set Portd.6                                                 'power relay on
Call Bklght
Display On                                                  'turn display on
Cls
Lcd " Power On !    "
Waitms 500
Cls
Porta = Inp_sel
Call Af_sel
Home Lowerline
Lcd "VolR=" ; R ; " VolL=" ; L ; "   "
Waitms 100
Enable Int0
End Sub
'-------Poweroff----------------------
Sub Poweroff:
Reset Portb.3                                               'mute PGA2310
Reset Portd.6                                               'power relay off
Reset Portd.7                                               'backlight off
Display Off                                                 'turn display off
Porta = &B00000000                                          ' mute
Waitms 500
Disable Int0
End Sub
'---------shift input Left----------
Sub Shiftlf:
Call Bklght
If Inp_sel >= 1 And Inp_sel < 32 Then
Rotate Inp_sel , Left
End If
Porta = Inp_sel
Call Af_sel
Waitms 200
End Sub
'--------shift input right----------
Sub Shiftrt:
Call Bklght
If Inp_sel >= 2 And Inp_sel < 33 Then
Rotate Inp_sel , Right
End If
Porta = Inp_sel
Call Af_sel
Waitms 200
End Sub
'-------bring volume up-----------
Sub Volup:
Call Bklght
   If L = 184 Then
        L = 182
   End If
   If R = 184 Then
        R = 182
   End If
        L = L + 2
        R = R + 2
   Home Lowerline
   Lcd "VolR=" ; R ; " VolL=" ; L ; "   "
   Call Spio
   Waitms 5
End Sub

'--------bring volume down----------
Sub Voldn:
Call Bklght
   If L = 0 Then
        L = 2
   End If
   If R = 0 Then
        R = 2
   End If
        L = L - 2
        R = R - 2
   Home Lowerline
   Lcd "VolR=" ; R ; " VolL=" ; L ; "   "
   Call Spio
   Waitms 5
End Sub
'------Af_sel---------------------------
Sub Af_sel:
Home Upper
If Inp_sel = 1 Then
Lcd "DVD    selected"
End If
If Inp_sel = 2 Then
Lcd "CD     selected"
End If
If Inp_sel = 4 Then
Lcd "Tuner  selected"
End If
If Inp_sel = 8 Then
Lcd "Tape   selected"
End If
If Inp_sel = 16 Then
Lcd "Aux1   selected"
End If
If Inp_sel = 32 Then
Lcd "Aux2   selected"
End If
'If Inp_sel = 64 Then
'Lcd "Aux3    selected"
'End If
'If Inp_sel = 128 Then
'Lcd "Aux4    selected"
'End If
End Sub
'------- Mute ----------
Sub Mute:
Call Bklght
   Mut = Not Mut
   If Mut = 1 Then
      Set Portb.3
      Porta = Inp_sel
      Home Lowerline
      Lcd "VolR=" ; R ; " VolL=" ; L ; "   "
      Wait 1
   Else
      Porta = &B00000000
      Reset Portb.3
      Home Lowerline
      Lcd "MUTE      !!!  "
      Wait 1
   End If
End Sub
'-----Send data to PGA2310------
Sub Spio:
   Spiinit
   Spiout L , 1
   Spiout R , 1
End Sub
'-----------Menu-----------------
Sub Menu:
G = G + 1
Call Bklght                                                 'backlight on
If G > 1 Then
   G = 0
End If
If G = 0 Then
Cls
   Home Lower
   Lcd " Adjust Volume  "
   Waitms 200
End If
If G = 1 Then
Cls
   Home Upper
   Lcd " Select Input   "
   Waitms 200
End If
End Sub
'------- Bklght------------------
Sub Bklght:
 Set Portb.6                                                'backlight on
 W = 0
 Timer1 = W                                                 'reset timer 1
End Sub
'---Nu le folosesc deocamdata--------------
'--------------Balance left-----------------
Sub Balance_r:
   If L = 254 Then
          L = 252
   End If
   If L = 0 Then
          L = 2
   End If
   If R = 0 Then
          R = 2
   End If
   If R = 254 Then
          R = 252
   End If
   If L < R Then
          L = L + 2
            Else
          R = R - 2
   End If
   Call Spio
End Sub
'------------Balance  right----------
Sub Balance_l
   If R = 0 Then
                  R = 2
   End If
   If R = 254 Then
                  R = 252
   End If
   If L = 0 Then
                  L = 2
   End If
   If L = 254 Then
                  L = 252
   End If
   If R < L Then
                        R = R + 2
   Else
                        L = L - 2
   End If
   Call Spio
End Sub